import plotly.figure_factory as ff
import plotly.graph_objects as go
import plotly
import json
import os
from decimal import Decimal

dir_path = os.path.dirname(os.path.realpath(__file__))

logcolorscale = [
        [
          0,
          '#482878'
        ],
        [
          0.0001,
          '#482878'
        ],
        [
          0.001,
          '#31688e'
        ],
        [
          0.01,
          '#1f9e89'
        ],
        [
          0.1,
          '#6ece58'
        ],
        [
          1,
          '#fde725'
        ]
      ]

results = []
texts = []
devicesY = []
algorithmsX = ['RSA512', 'RSA768', 'RSA1024', 'RSA2048', 'RSA3072', 'EC224', 'EC256', 'EC384', 'EC521']
benchmarkNames = ['benchmarkRSA512', 'benchmarkRSA768', 'benchmarkRSA1024', 'benchmarkRSA2048', 'benchmarkRSA3072', 
                  'benchmarkEC224', 'benchmarkEC256', 'benchmarkEC384', 'benchmarkEC521']
benchmarkClassName = 'cz.vutbr.benchmark.KeyPairGenerationBenchmark'

for device in os.listdir("{}/results".format(dir_path)):
    filePath = "{}/results/{}/result.json".format(dir_path, device)
    content = open(filePath, "r").read()
    devicesY.append(device)
    decoded = json.loads(content)
    benchmarkResults = decoded['benchmarks']
    result = []
    text = []
    for benchmarkName in benchmarkNames:
      for benchmark in benchmarkResults:
          if benchmark['className'] == benchmarkClassName and benchmark['name'] == benchmarkName:
              metric = benchmark['metrics']['timeNs']['median']
              result.append(metric/1000000)
              text.append('%.2f' % Decimal(metric/1000000))
              break
    results.append(result)
    texts.append(text)


fig = ff.create_annotated_heatmap(results, x=algorithmsX, y=devicesY, annotation_text=texts, colorscale=logcolorscale, showscale = True)
fig.update_layout(
    xaxis_title="Algorithm",
    yaxis_title="Device",
    autosize=False,
    width=1280,
    height=720,
)
fig['layout']['xaxis']['side'] = 'bottom'
fig['data'][0]['colorbar'].tickformat = ",.1"
fig['data'][0]['colorbar'].ticksuffix = " ms"
fig.write_image("{}/pdf/asymmetric_key_creation.pdf".format(dir_path))